#include "bbmaracasvisuImageActor.h"
#include "bbcreaMaracasVisuPackage.h"

#include "vtkImageShiftScale.h" 

namespace bbcreaMaracasVisu
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaMaracasVisu,ImageActor)
BBTK_BLACK_BOX_IMPLEMENTATION(ImageActor,bbtk::AtomicBlackBox);
void ImageActor::Process()
{

		//JCP 04/04/09
		vtkRenderer *render				= bbGetInputRenderer();
		vtkImageData *img				= bbGetInputIn();
		vtkLinearTransform* transform	= bbGetInputTransform();

		if(img != NULL){
			
			imageshiftscale->SetInput( img );	
			imageshiftscale->SetOutputScalarTypeToUnsignedChar();	
			imageactor->SetInput( imageshiftscale->GetOutput() );	
			if (transform!=NULL){
			  imageactor->SetUserTransform( transform );	
			} // transform
			if(render != NULL ){
				render->AddActor( imageactor );
			} // render
			bbSetOutputOut(imageactor);
		} // img
			
			
		// Interface Update
		if ((firsttime==true) && (bbGetInputRenderer()!=NULL ))
		{
				firsttime=false;
				bbGetInputRenderer()->AddActor( imageactor );
		}
		
		bbSetOutputOut(imageactor);
	
}
void ImageActor::bbUserSetDefaultValues()
{
    firsttime = true;
    imageactor = NULL;

    bbSetInputIn(NULL);
    bbSetInputTransform(NULL);
    bbSetInputRenderer(NULL);
  
}

	
	//-----------------------------------------------------------------	
	void ImageActor::bbUserInitializeProcessing()
	{
		imageactor = vtkImageActor::New();
		imageshiftscale = vtkImageShiftScale::New();
	}
	
	//-----------------------------------------------------------------	
	void ImageActor::bbUserFinalizeProcessing()
	{
	}
	
	//-----------------------------------------------------------------	
}
// EO namespace bbcreaMaracasVisu


