#include "manualContourModelLine.h"

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

//AD: 02-09

manualContourModelLine::manualContourModelLine()
: manualContourModel()
{
	SetNumberOfPointsSpline(20);
	this->SetCloseContour(false);
}

manualContourModelLine::~manualContourModelLine()
{
}


// ----------------------------------------------------------------------------
manualContourModelLine * manualContourModelLine :: Clone()  // virtual 
{
	manualContourModelLine * clone = new manualContourModelLine();
	CopyAttributesTo(clone);
	return clone;
}

// ---------------------------------------------------------------------------

void manualContourModelLine::CopyAttributesTo( manualContourModelLine * cloneObject)
{
	manualContourModel::CopyAttributesTo(cloneObject);
}

//----------------------------------------------------------------
int manualContourModelLine::GetTypeModel() //virtual 
{
	return 6;
}


//----------------------------------------------------------------
/*
void manualContourModelLine::GetSpline_i_Point(int i, double *x, double *y, double *z) // virtual
{
	int np	= GetSizeLstPoints();
	if (np==0)
	{
		*x	= 0;
		*y	= 0;
		*z	= 0;
	}
	if (np==1)
	{
		manualPoint	*mp;
		mp	= GetManualPoint(0);
		*x	= mp->GetX();
		*y	= mp->GetY();
		*z	= mp->GetZ();
	}
	if (np==2)
	{
		manualPoint	*mp;

		if (i==0)
		{
			mp = GetManualPoint(0);
		} 
		else if (i==1)
		{
			mp = GetManualPoint(1);
		}

		*x	= mp->GetX();
		*y	= mp->GetY();
		*z	= mp->GetZ();
	}

}
*/

