#ifndef VTKINTERACTORSTYLEBASEVIEW2D_H_
#define VTKINTERACTORSTYLEBASEVIEW2D_H_

#include "vtkInteractorScrollZ.h"

#include "manualInteractorWindowLevel.h"
//------------------------------------------------------------------
//------------------------------------------------------------------
//------------------------------------------------------------------

class creaMaracasVisu_EXPORT vtkInteractorStyleBaseView2D : public vtkInteractorStyleBaseView{
public:
	vtkInteractorStyleBaseView2D();
	~vtkInteractorStyleBaseView2D();
	static vtkInteractorStyleBaseView2D *New();

	// RaC 04-2010 Look for the description of new changes in vtkInteractorStyleBaseView2D constructor.
	void  SetInteractorScrollZ(vtkInteractorScrollZ* interactorScroll);
	void  SetInteractorWindowLevel(manualInteractorWindowLevel* interactorWindowLevel);

	virtual void  OnMouseMove();
	virtual void  OnLeftButtonDown(); 
	virtual void  OnLeftButtonUp();
	virtual void  OnMiddleButtonDown(); 
	virtual void  OnMiddleButtonUp();
	virtual void  OnRightButtonDown();
	virtual void  OnRightButtonUp();


protected:

private:
	manualInteractorWindowLevel		*_manualinteractorwindowlevel;
	vtkInteractorScrollZ			*_vtkInteractorScrollZ;

};


#endif /*VTKINTERACTORSTYLEBASEVIEW2D_H_*/
