#ifndef WXVTKCLIPPING3DVIEWCNTRLPANEL_H_
#define WXVTKCLIPPING3DVIEWCNTRLPANEL_H_

#include "wxVtkClipping3DView.h"
#include "wx/wx.h"

class wxVtkClipping3DViewCntrlPanel: public wxPanel
{
public:
	wxVtkClipping3DViewCntrlPanel(wxWindow *parent, wxVtkClipping3DView *_wxvtkclipping3Dview);
	~wxVtkClipping3DViewCntrlPanel();
			void	OnSurface(wxCommandEvent& event);
			void	OnRepresentationSurfaceWireFrame(wxCommandEvent& event);
			void	OnVisibleVolume(wxCommandEvent& event);
			void	OnVisibleBoxSurface(wxCommandEvent& event);
			void	OnVisibleBoxVolume(wxCommandEvent& event);
			void	OnColor(wxCommandEvent& event);
			void	OnVisibleSurface(wxCommandEvent& event);
			void	OnOpacity(wxScrollEvent& event);
			void	OnIsoValue(wxScrollEvent& event);
			void	OnIsoValueSpin(wxScrollEvent& event);
	virtual void	Refresh();
			void	OnBtnCreateFileSTL(wxCommandEvent& event);
			void	OnBtnSaveRawVolume(wxCommandEvent& event);
			void	OnBtnVolumeFunctions(wxCommandEvent& event);
			void	OnBtnMeshVTKLoad(wxCommandEvent& event);


private:
	wxVtkClipping3DView	*_wxvtkclipping3Dview;
	wxSlider			*_opacity;
	wxSlider			*_isoValue;
	wxSlider			*_isoValueSpin;
	wxRadioButton		*_surfA;
	wxRadioButton		*_surfB;
	wxRadioButton		*_surfC;
	wxRadioButton		*_surfD;
	wxCheckBox			*_visible;
	wxButton			*_color;

	wxRadioButton		*_wireFrameRep;
	wxRadioButton		*_surfaceRep;

	int				GetIdTissue();
protected:

};

#endif /*WXVTKCLIPPING3DVIEWCNTRLPANEL_H_*/
