#include "bbcreaMaracasVisuSurfaceRendering.h"
#include "bbcreaMaracasVisuPackage.h"


#include "wxMaracasSurfaceRendering.h"

namespace bbcreaMaracasVisu
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaMaracasVisu,SurfaceRendering)
BBTK_BLACK_BOX_IMPLEMENTATION(SurfaceRendering,bbtk::WxBlackBox);
void SurfaceRendering::Process()
{

	wxMaracasSurfaceRendering* surrend = wxMaracasSurfaceRendering::getInstance();
	std::vector<vtkImageData*> tempvect;
	int i;

	if(surrend != NULL){
		vtkRenderer* renderer = bbGetInputRenderer();
		vtkRenderWindowInteractor* interactor = bbGetInputInteractor();
		surrend->setRenderer(renderer);
		surrend->setInteractor(interactor);
		vtkImageData* prop3D;
		tempvect.push_back(bbGetInputIn0());
		tempvect.push_back(bbGetInputIn1());
		tempvect.push_back(bbGetInputIn2());
		tempvect.push_back(bbGetInputIn3());
		tempvect.push_back(bbGetInputIn4());

		for(i = 0; i < tempvect.size();i++){
			prop3D = tempvect[i];
			if(prop3D != NULL&&renderer != NULL){
				surrend->addPropMHD(prop3D);
			}
		}
	}  
}
void SurfaceRendering::CreateWidget(wxWindow* parent)
{


	//std::cout << "Your application's directory is: " << path;

	wxMaracasSurfaceRendering* surrend = wxMaracasSurfaceRendering::getInstance(parent);
	//GetDllDirectory(_MAX_PATH, currentPath);
	//std::cout << "Your application's directory is: " << GetDllDirectory(_MAX_PATH, currentPath)<<std::endl;

	bbSetOutputWidget(surrend);
  
}

	//-----------------------------------------------------------------	
	void SurfaceRendering::bbUserSetDefaultValues()
	{
		bbSetInputIn0(NULL);
		bbSetInputIn1(NULL);
		bbSetInputIn2(NULL);
		bbSetInputIn3(NULL);
		bbSetInputIn4(NULL);
		bbSetInputRenderer(NULL);
		bbSetInputInteractor(NULL);
		bbSetOutputWidget(NULL);
		bbSetOutputOut1(NULL);
		bbSetOutputOut2(NULL);
		bbSetOutputOut3(NULL);
		bbSetOutputOut4(NULL);
	}
	
	//-----------------------------------------------------------------	
	void SurfaceRendering::bbUserInitializeProcessing()
	{
	}
	
	//-----------------------------------------------------------------	
	void SurfaceRendering::bbUserFinalizeProcessing()
	{
	}
	
	//-----------------------------------------------------------------	
	
	

}
// EO namespace bbcreaMaracasVisu


