/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: wxMaracas_SegmentationFM3D.cxx,v $
  Language:  C++
  Date:      $Date: 2009/05/14 13:54:54 $
  Version:   $Revision: 1.1 $

  Copyright: (c) 2002, 2003
  License:

     This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/


#include <wx/splitter.h>
#include "wxMaracas_SegmentationFM3D.h"


//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
wxMaracas_SegmentationFM3D::wxMaracas_SegmentationFM3D( wxWindow* parent, marImageData* marimagedata,double voxelSize )
: wxPanel( parent, -1, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL)
{

  // Create the main frame window
	_MPR = new wxSegmentationFM3DWidget( this, marimagedata , voxelSize);
	wxBoxSizer* szTop = new wxBoxSizer( wxVERTICAL );
	szTop->Add( _MPR, 1  , wxEXPAND |  wxALL , 0 );
	this->SetAutoLayout( true );
	this->SetSizer( szTop );
	szTop->Fit( this );
	szTop->SetSizeHints( this );
//EEDxx2.4
//	FitInside();

}
//----------------------------------------------------------------------------
wxMaracas_SegmentationFM3D::~wxMaracas_SegmentationFM3D( )
{
//EEDxx2.4 DELETE
//	delete _MPR;
  // Nothing
}
//----------------------------------------------------------------------------
void wxMaracas_SegmentationFM3D::ConfigureVTK( )
{
  _MPR->ConfigureVTK();
}
//----------------------------------------------------------------------------
vtkMPRBaseData  *wxMaracas_SegmentationFM3D::GetVtkMPRBaseData()
{
	return _MPR->GetVtkMPRBaseData();
}

//----------------------------------------------------------------------------
vtkPlane2DView *wxMaracas_SegmentationFM3D::GetVtkPlane2DView()
{
	return _MPR->GetVtkPlane2DView();
}




// EOF 




