#ifndef manualCircleControler_h
#define manualCircleControler_h

#include "manualContourControler.h"

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

// EED08
class creaMaracasVisu_EXPORT manualCircleControler: public manualContourControler
{
public:
	manualCircleControler();
	virtual ~manualCircleControler();
	virtual manualCircleControler * Clone();
	void CopyAttributesTo( manualCircleControler *cloneObject );

	virtual void MouseClickLeft(int x, int y);
	virtual void MouseMove(int x, int y );
	virtual void DeleteActualMousePoint(int x, int y);
			void InitRoi(int ww, int hh, double porcentage);
//			void SetRoi(int x1, int y1,int x2, int y2);
	virtual void Configure();


private:
	int	bakIdPoint;
};

#endif // manualCircleControler_h
