#ifndef manualContourControler_h
#define manualContourControler_h

#include "manualContourBaseControler.h"

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------


class creaMaracasVisu_EXPORT manualContourControler: public manualContourBaseControler
{
public:
	manualContourControler();
	virtual ~manualContourControler();
	virtual manualContourControler * Clone();
	void CopyAttributesTo( manualContourControler *cloneObject );

	virtual void	MouseClickLeft(int x, int y);
	virtual void	MouseMove(int x, int y);
	virtual void    MouseDLeft( int x, int y);		
	void SetEasyCreation(bool easyCreation);
	bool GetEasyCreation();

	virtual void Configure();

protected:
	int		_bakIdPoint;
private:
	bool	_easyCreation;
};

#endif // manualContourControler_h
