#ifndef manualViewRotationTool_h
#define manualViewRotationTool_h
#include "manualViewLine.h"

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------


class creaMaracasVisu_EXPORT manualViewRotationTool: public manualViewContour
{
public:
	manualViewRotationTool();
	virtual ~manualViewRotationTool();

	virtual int GetType();
	virtual manualViewRotationTool * Clone();
	void CopyAttributesTo( manualViewRotationTool *cloneObject );

	virtual void InitMove(int x, int y, int z);
	virtual void MoveContour(int x, int y, int z);
	void GetMinMax(double &minX,double &minY, double &maxX, double &maxY);

private:
	double				_dp0[3];
	double				_dp1[3];
	double				_dp2[3];
};


#endif // manualViewRotationTool_h
