#ifndef VTKBASEDATA_H_
#define VTKBASEDATA_H_

#include "marTypes.h"

#include "marImageData.h"
#include "vtkImageData.h"

class creaMaracasVisu_EXPORT vtkBaseData {
public:
	vtkBaseData();
	virtual ~vtkBaseData();
	vtkImageData*	GetImageData();
	marImageData*	GetMarImageData();
			void	SetMarImageData(marImageData *marimagedata);
	virtual void	Configure();
	double			GetZ();
	void			SetZ(double z);

	int				GetT();
	void			SetT(double t);

protected:
	marImageData	*_marImageData;
	double			_z;
	int				_t;
};

#endif /*VTKBASEDATA_H_*/
