#ifndef VTKINFOTEXTIMAGE_H_
#define VTKINFOTEXTIMAGE_H_


#include "wxVtk2DBaseView.h"

class vtkInfoTextImage{
public:
	vtkInfoTextImage();
	~vtkInfoTextImage();
	void SetWxVtk2DBaseView(wxVtk2DBaseView *wxvtk2Dbaseview);
	void SetMarImageData(marImageData *marimagedata);
	void Configure();
	void PutPixelIntensity(int x, int y, int z);
	void PutPosition(int x, int y, int z);
	void PutColorLevel();
	void PutWindowLevel();


protected:
private:

	marImageData	*_marimagedata;
	wxVtk2DBaseView	*_wxvtk2Dbaseview;
	vtkTextActor	*_vtkText_WindowLevel;
	vtkTextActor	*_vtkText_ColorLevel;
	vtkTextActor	*_vtkText_position;
	vtkTextActor	*_vtkText_pixelIntensity;

	vtkTextActor	*Create_Text_Label(int px, int py);
};


#endif /*VTKINFOTEXTIMAGE_H_*/
