
#include "wxVTKRenderWindowInteractorPlus.h"
#include "vtkInteractorStyleBaseView.h"

BEGIN_EVENT_TABLE( wxVTKRenderWindowInteractorPlus, wxVTKRenderWindowInteractor )
    EVT_LEFT_DCLICK( wxVTKRenderWindowInteractorPlus::OnLeftDClick )
    EVT_RIGHT_DCLICK( wxVTKRenderWindowInteractorPlus::OnRightDClick )
    EVT_MIDDLE_DCLICK( wxVTKRenderWindowInteractorPlus::OnMiddleDClick )
	EVT_MOUSEWHEEL( wxVTKRenderWindowInteractorPlus::OnMouseWheel )
END_EVENT_TABLE( );

//-------------------------------------------------------------------
wxVTKRenderWindowInteractorPlus::wxVTKRenderWindowInteractorPlus() 
: wxVTKRenderWindowInteractor()
{
}


//-------------------------------------------------------------------
wxVTKRenderWindowInteractorPlus::wxVTKRenderWindowInteractorPlus(wxWindow *parent, wxVtkBaseView *wxvtkbaseview)
: wxVTKRenderWindowInteractor(parent, -1)
{
	_wxvtkbaseview = wxvtkbaseview;
}

//-------------------------------------------------------------------
wxVTKRenderWindowInteractorPlus::~wxVTKRenderWindowInteractorPlus()
{
}

//---------------------------------------------------------------------------
wxVTKRenderWindowInteractorPlus * wxVTKRenderWindowInteractorPlus::New()
{
  // we don't make use of the objectfactory, because we're not registered
  return new wxVTKRenderWindowInteractorPlus;
}

//-------------------------------------------------------------------
void wxVTKRenderWindowInteractorPlus::OnLeftDClick( wxMouseEvent& event )
{
	/**
	 * JCP 14/05/09	 
	wxvtkbaseview->GetInteractorStyleBaseView()->OnLeftDClick();
	*/
	((vtkInteractorStyleBaseView*)_wxvtkbaseview->GetInteractorStyleBaseView())->OnLeftDClick();
}
//-------------------------------------------------------------------
void wxVTKRenderWindowInteractorPlus::OnRightDClick( wxMouseEvent& event )
{
	/**
		 * JCP 14/05/09		 
	_wxvtkbaseview->GetInteractorStyleBaseView()->OnRightDClick();
	*/
	((vtkInteractorStyleBaseView*)_wxvtkbaseview->GetInteractorStyleBaseView())->OnRightDClick();
}
//-------------------------------------------------------------------
void wxVTKRenderWindowInteractorPlus::OnMiddleDClick( wxMouseEvent& event )
{
	/**
		 * JCP 14/05/09
		 
	_wxvtkbaseview->GetInteractorStyleBaseView()->OnMiddleDClick();
	*/
	((vtkInteractorStyleBaseView*)_wxvtkbaseview->GetInteractorStyleBaseView())->OnMiddleDClick();
}
//-------------------------------------------------------------------
void wxVTKRenderWindowInteractorPlus::OnMouseWheel( wxMouseEvent& event )
{
	/**
		 * JCP 14/05/09
		 
	_wxvtkbaseview->GetInteractorStyleBaseView()->OnMouseWheel();
	*/
	((vtkInteractorStyleBaseView*)_wxvtkbaseview->GetInteractorStyleBaseView())->OnMouseWheel();
}


