#ifndef WXVTK2DBASEVIEW_H_
#define WXVTK2DBASEVIEW_H_

#include "wxVtkBaseView.h"
#include "vtkImageViewer2_XYZ.h"

//class vtkInteractorStyleBaseView;
#include "vtkInteractorStyleBaseView.h"
class vtkInfoTextImage;
class vtkInfoTextImageInteractor;



//------------------------------------------------------------------


class creaMaracasVisu_EXPORT wxVtk2DBaseView: public wxVtkBaseView{
public:
	wxVtk2DBaseView(wxWindow *parent);
	virtual ~wxVtk2DBaseView();
	virtual void			Configure(bool okimage=true);
	vtkImageViewer2_XYZ*	_imageViewer2XYZ;
	vtkBaseData*			GetVtkBaseData();
	void					SetVtkBaseData(vtkBaseData *vtkbasedata);
	virtual void			Refresh();
	virtual void			ResetView();
	virtual int				GetActualSlice();
	virtual	void			SetActualSlice(int slice);
			void			SetInteractorStyleImage(vtkInteractorStyleBaseView *interactorstylebaseview);

	virtual vtkRenderer*		GetRenderer();
	virtual vtkRenderWindow*	GetRenWin();
	virtual void			TransformCoordinate_spacing_ViewToModel(double &X,double &Y, double &Z);
	virtual void			TransformCoordinate_spacing_ModelToView(double &X,double &Y, double &Z);
	virtual void			GetSpacing(double spc[3]);

	void setColorTransferFunction(vtkColorTransferFunction* colortable);

	void setWindowLevel(double level);

	void setColorLevel(double level);

private:
	vtkBaseData							*_vtkbasedata;

	vtkInfoTextImage					*_vtkIinfoTextImage;
	vtkInfoTextImageInteractor			*_vtkIinfoTextImageInteractor;

protected:

};

#endif /*WXVTK2DBASEVIEW_H_*/
