#ifndef WXWIDGETMESURE2D_PLANE_H_
#define WXWIDGETMESURE2D_PLANE_H_

#include "wxWidgetMesure2D.h"
#include "wxVtk2DBaseView.h"

class wxWidgetMesure2D_Plane : public wxWidgetMesure2D
{
public:
	 wxWidgetMesure2D_Plane(wxWindow *parent);
	 ~wxWidgetMesure2D_Plane();
	void			OnActiveLine(wxCommandEvent& event);
	void			OnActiveCirlcle(wxCommandEvent& event);
	virtual void	ConfigureA(wxVtk2DBaseView *wxvtk2Dbaseview);
	void			ConfigureCircleLine();
	void			CircleLine();

protected:
	virtual wxWindow		*CreateWin1a(wxWindow *parent);
private:
	wxCheckBox				*_cb_line; 
	wxCheckBox				*_cb_circle; 

	// Circle 1
	vtkPoints					*_ptsCircle1;
	vtkActor					*_circle1Actor;
	vtkPolyDataMapper			*_circle1Mapper;
    vtkPolyData					*_pdCircle1;
	// Circle 2
	vtkPoints					*_ptsCircle2;
	vtkActor					*_circle2Actor;
	vtkPolyDataMapper			*_circle2Mapper;
    vtkPolyData					*_pdCircle2;
	// line reference 1
	vtkPoints					*_ptsLineRef1;
	vtkActor					*_lineRef1Actor;
	vtkPolyDataMapper			*_lineRef1Mapper;
    vtkPolyData					*_pdLineRef1;
	// line reference 2
	vtkPoints					*_ptsLineRef2;
	vtkActor					*_lineRef2Actor;
	vtkPolyDataMapper			*_lineRef2Mapper;
    vtkPolyData					*_pdLineRef2;

	void SetVisibleCircle( bool ok );

};

#endif /*WXWIDGETMESURE2D_PLANE_H_*/
